import { Component, OnInit } from '@angular/core';
import {BusinessService} from '../business.service';
import {NzMessageService} from 'ng-zorro-antd';
import {color} from '../../app.constants';

@Component({
  selector: 'smart-b-overview',
  templateUrl: './b-overview.component.html',
  styles: []
})
export class BOverviewComponent implements OnInit {

  color = color;
  list;
  constructor(private busineSer:BusinessService,private message:NzMessageService) { }

  ngOnInit() {
    this.getList();
  }

  getList(){
    this.busineSer.itserviceOverview().subscribe(
        (res)=>{
          if(res.errCode == 10000){
            this.list = res.data;
          }else{
            this.message.error(res.errMsg);
          }
        }
    )
  }

}
